--[[ Slash Commands ]]

  local expMop = select(4, GetBuildInfo()) >= 50000
  local expCat = select(4, GetBuildInfo()) >= 40000 and select(4, GetBuildInfo()) < 50000
  local fixRModules = {};
  FixR = {};
  
  local loadModule = nil
  local FIXR_VERSION = GetAddOnMetadata("FixR", "Version");
  local DefaultFixROptions = {
    ["FixRVersion"] = FIXR_VERSION;
    ["Modules"] = {
      ["MoveLFDTooltip"] = {
        ["enabled"] = false;
      };
      ["MovePVPCaptureBar"] = {
        ["enabled"] = false;
      };
      ["MoveGameTooltip"] = {
        ["enabled"] = false;
      };
      ["QuestRewardSelect"] = {
        ["enabled"] = false;
        ["autoComplete"] = false;
        ["autoAccept"] = false;
        ["autoAcceptDaily"] = false;
        ["autoAcceptLowLevel"] = false;
      };
      ["ExtraActionButton"] = {
        ["enabled"] = false;
        ["framePoint"] = "CENTER";
        ["frameRelativeTo"] = "UIParent";
        ["frameRelativePoint"] = "CENTER";
        ["frameOffsetX"] = 0;
        ["frameOffsetY"] = 0;
      };
      ["Inspect"] = {
        ["enabled"] = false;
      };
      ["Minimap"] = {
        ["enabled"] = false;
      };
      ["testmodul"] = {
        ["enabled"] = false;
        ["option1"] = "CENTER";
        ["opt2"] = 2.2;
      };
    };
  };
  function FixR_FreshOptions()
    FixROptions = CloneTable(DefaultFixROptions);
  end
  function FixR_UpdateOptionsArray()
    TempFixROptions = CloneTable(DefaultFixROptions);
    CopyValues(FixROptions,TempFixROptions);
    FixROptions = TempFixROptions
  end
  function ShowValues(t,appx) -- Print array
    local i, v = next(t, nil); -- i is an index of t, v = t[i]
    while i do
      if type(v)=="table" then
        print(appx.."'"..i.."' = {");
        ShowValues(v,"  "..appx);
        print(appx.."};");
      elseif type(v)=="boolean" then
        print(appx.."'"..i.."' = "..(v and "true" or "false")..";");
      elseif type(v)=="function" then
        print(appx.."'"..i.."' = <function>;");
      else
        print(appx.."'"..i.."' = "..v..";");
      end
      i, v = next(t, i); -- get next index
    end
  end
  function CopyValues(from,to)
    local i, v = next(from, nil); -- i is an index of from, v = from[i]
    while i do
      if type(v)=="table" then
        if to[i] ~= nil then
          if type(to[i])=="table" then
            CopyValues(v,to[i]);
          end
        end
      else
        if to[i] ~= nil then
          if type(to[i])~="table" then
            to[i] = v;
          end
        end
      end
      i, v = next(from, i); -- get next index
    end
  end
  --from "SCT" by "Grayhoof"
  function CloneTable(t) -- return a copy of the table t
    local new = {}; -- create a new table
    local i, v = next(t, nil); -- i is an index of t, v = t[i]
    while i do
      if type(v)=="table" then
        v=CloneTable(v);
      end
      new[i] = v;
      i, v = next(t, i); -- get next index
    end
    return new;
  end
  local function mysplit(inputstr, sep)
    if sep == nil then
      sep = "%s"
    end
    t={} ; i=1
    for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
      t[i] = str
      i = i + 1
    end
    return t
  end
  local function round(num, idp)
    if idp and idp>0 then
      local mult = 10^idp
      return math.floor(num * mult + 0.5) / mult
    end
    return math.floor(num + 0.5)
  end
  
  function FixR:NewModule(name)
    if not fixRModules[name] then
      fixRModules[name] = {};
    end
    return fixRModules[name]
  end
  
  function FixR:Echo(...)
    fixR_Echo(...)
  end
  
  function FixR:IsCat()
    return expCat
  end
  function FixR:IsMop()
    return expMop
  end
  function FixR:Round(num, idp)
    return round(num, idp)
  end

  local fixRFrame = CreateFrame("Frame")

  local fixRFrameEvents = {};
  function fixRFrameEvents:PLAYER_ENTERING_WORLD(...)
    fixRFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
    if ( FixROptions == nil) then
      fixR_Echo("FixR: Fresh install.")
      FixR_FreshOptions();
    elseif FixROptions["FixRVersion"] ~= FIXR_VERSION then
      fixR_Echo("FixR: New version installed. Check your options! (old: ".. FixROptions["FixRVersion"] .. ", new: " .. FIXR_VERSION .. ")")
      FixR_UpdateOptionsArray();
      FixROptions["FixRVersion"] = FIXR_VERSION
    else
      FixR_UpdateOptionsArray();
    end
    
    for k, v in pairs(FixROptions["Modules"]) do
      if v and v["enabled"] then
        loadModule(k)
      end
    end
  end
  function fixRFrameEvents:PLAYER_LOGOUT(...)
    --update module options
    for k, v in pairs(fixRModules) do
      if type(FixROptions["Modules"][k]) == "table" and type(v.O) == "table" then --v.O is not a table (nil) if the module had not been loaded
        FixROptions["Modules"][k] = CloneTable(v.O)
      end
    end
  end
  fixRFrame:SetScript("OnEvent", function(self, event, ...)
    fixRFrameEvents[event](self, ...); -- call one of the functions above
  end);
  for k, v in pairs(fixRFrameEvents) do
    fixRFrame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
  
  function loadModule(m)
    if fixRModules[m] then
      --update modul options
      fixRModules[m].O = CloneTable(FixROptions["Modules"][m])
      fixRModules[m].O["enabled"] = true
      fixRModules[m].DefaultO = CloneTable(DefaultFixROptions["Modules"][m])
      if fixRModules[m]["Load"] then
        local ok, err = pcall(fixRModules[m]["Load"])
        if not ok then
          fixR_Echo("|cffff8888Error while loading module ", m, "|cffff8888: "..err)
        end
      end
    end
  end
  function unloadModule(m)
    if fixRModules[m] then
      fixRModules[m].O["enabled"] = false
      if fixRModules[m]["Unload"] then
        local ok, err = pcall(fixRModules[m]["Unload"])
        if not ok then
          fixR_Echo("|cffff8888Error while unloading module ", m, "|cffff8888: "..err)
        end
      end
    end
  end
  function isModuleLoaded(m)
    return FixROptions["Modules"][m]["enabled"]
  end
  
  function fixR_Echo(...)
    local t = {...}
    if #t > 0 then
      DEFAULT_CHAT_FRAME:AddMessage("|cffaaaaff"..table.concat(t, "|cffaaaaff").."|r")
    else
      DEFAULT_CHAT_FRAME:AddMessage("|cffff0000nil|r")
    end
  end

  SLASH_FIXR1 = "/fixr" --SLASH_FIXR2 = "/fixing"
  SlashCmdList["FIXR"] = function(msg, editbox)
    msg = msg or ""
    args = mysplit(msg, " ")
    local isHandled = false
    for k, v in pairs(FixROptions["Modules"]) do
      if not isHandled and string.lower(k) == string.lower(args[1] or "") then
        isHandled = true
        if args[2] ~= nil then -- only SetOption if option is given
          if isModuleLoaded(k) then -- only SetOption if module is loaded
            if args[3] ~= nil then
              if fixRModules[k] and fixRModules[k]["SetOption"] then
                fixRModules[k]:SetOption(args[2], args[3])
              end
            else
              if fixRModules[k] and fixRModules[k]["SetOption"] then
                fixRModules[k]:SetOption(args[2])
              end
            end
          end
        else
          local loaded = FixROptions["Modules"][k]["enabled"]
          loaded = not (loaded or false)
          if loaded then --not yet loaded
            loadModule(k)
            fixR_Echo(k.." |cffaaffaaenabled")
          else --loaded
            unloadModule(k)
            fixR_Echo(k.." |cffff8888disabled")
          end
          FixROptions["Modules"][k]["enabled"] = loaded
        end
      end
    end
    if not isHandled then
      fixR_Echo("FixR v|cffaaffaa"..FIXR_VERSION)
      for k, v in pairs(FixROptions["Modules"]) do
        local bln = v["enabled"]
        fixR_Echo(k..(bln and ": |cffaaffaaEnabled" or ": |cffff8888Disabled"))
        if bln then
          if fixRModules[k] and fixRModules[k]["ShowOptions"] then
            fixRModules[k]:ShowOptions()
          end
        end
      end
    end
  end

--talents (feral tank)
--/run LearnTalents(1, 5, 9, 10, 14, 16)
--/script print(GetMouseFocus():GetName())

