--[[ Minimap
     Work in progress
  ]]

if not FixR then return end

local M = FixR:NewModule("Minimap")

local MMFrame = nil
local TexFrame = nil
local MMFrameEvents = {}
local Scale = 1
local newScale = 1
local ScaleMin, ScaleMax, ScaleInterval = 0.5, 10, 0.5
local WorldFramesScaleHide, WorldFramesScaleShowFull = 5, 1
local TexSizeX, TexSizeY = 10, 10
local TexMargin = 0

local ScrollDestinationX, ScrollDestinationY = 0, 0 --Carbonite.lua:21734
local currentMapCenterX, currentMapCenterY = 0, 0

local lastMapOffX, lastMapOffY = 0, 0
local lastCursorX, lastCursorY = 0, 0
local dragging = false
local draggingUpdateLocked = false
local updateInterval, timeSinceLastUpdate = 0.05, 0
local updateCounter = 0

local textures = {} --x=1..128, y=1..84
fixrTextures = nil
local texSizeTotal = {
  ["w"] = 128 * TexSizeX;
  ["h"] = 84 * TexSizeY;
};

local WorldFrames = {}
--fixrWorldFrames = WorldFrames
local texOffsetsWorld = {
  [1] = {
    ["x"] = 6.5*TexSizeX;
    ["y"] = 0*TexSizeY;
    --["w"] = floor(128 * TexSizeX / 4);
    --["h"] = floor(84 * TexSizeY / 3);
    ["w"] = floor(28 * TexSizeX);
    ["h"] = floor(28 * TexSizeY);
    ["name"] = "World";
  };
};

local ContinentFrames = {}
local texOffsetsContinents = {
  --[[
  [1] = {
    ["x"] = 0;
    ["y"] = 0;
    ["w"] = 10 * TexSizeX;
    ["h"] = 10 * TexSizeY;
    ["name"] = "Azeroth";
    ["desc"] = "EasternKingdoms";
  };
  --]]
};

--local activeTexs = {} -- 1..9

local texOffsets = { --{x oder y} /120*11 im Screenshot
  ["EasternKingdoms"] = {
    ["x"] = 81 * TexSizeX;
    ["y"] = -20 * TexSizeY;
    ["xL"] = 17;
    ["yL"] = 22;
    ["name"] = "Azeroth";
    ["tiles"] = {
      ["17"] = {37, 48};["18"] = {37, 48};["19"] = {37, 48};["20"] = {37, 48};["21"] = {37, 48};["22"] = {33, 48};["23"] = {33, 48};["24"] = {33, 48, 53, 55};["25"] = {22, 58};["26"] = {22, 58};["27"] = {22, 61};["28"] = {22, 61};["29"] = {22, 61};["30"] = {22, 61};["31"] = {22, 61};["32"] = {22, 61};["33"] = {22, 61};["34"] = {22, 61};
      --[[
      ["35"] = {20, 58};
      ["36"] = {20, 57};
      ["37"] = {20, 56};
      ["38"] = {20, 56};
      ["39"] = {20, 56};
      ["40"] = {20, 56};
      --]]
      ["35"] = {24, 58};["36"] = {24, 57};["37"] = {24, 56};["38"] = {24, 56};["39"] = {24, 56};["40"] = {24, 56};["41"] = {23, 53};["42"] = {23, 52};["43"] = {23, 45};["44"] = {25, 30, 35, 42};["45"] = {35, 42};
    };
  };
  --[[ --Deepholm
  ["Deepholm"] = {
    ["x"] = 0;
    ["y"] = 0;
    ["xL"] = 26;
    ["yL"] = 25;
    ["name"] = "Deephome";
    ["tiles"] = {
      ["26"] = {25, 34};
      ["27"] = {25, 34};
      ["28"] = {25, 34};
      ["29"] = {25, 34};
      ["30"] = {25, 34};
      ["31"] = {25, 34};
      ["32"] = {25, 34};
      ["33"] = {25, 34};
      ["34"] = {25, 34};
      ["35"] = {25, 34};
    };
  };
  --]]
  --[[ --EX01Outland
  ["EX01Outland"] = {
    ["x"] = 0;
    ["y"] = 0;
    ["xL"] = 12;
    ["yL"] = 21;
    ["name"] = "Expansion01";
    ["tiles"] = {
      ["12"] = {26, 41};
      ["13"] = {26, 41};
      ["14"] = {26, 41};
      ["15"] = {21, 41};
      ["16"] = {21, 41};
      ["17"] = {21, 42};
      ["18"] = {21, 42};
      ["19"] = {21, 42};
      ["20"] = {21, 42};
      ["21"] = {21, 42};
      ["22"] = {21, 42};
      ["23"] = {21, 42};
      ["24"] = {21, 42};
      ["25"] = {21, 42};
      ["26"] = {21, 42};
      ["27"] = {21, 42};
      ["28"] = {21, 42};
      ["29"] = {21, 42};
      ["30"] = {21, 42};
      ["31"] = {21, 42};
      ["32"] = {30, 42};
      ["33"] = {30, 42};
      ["34"] = {32, 42};
      ["35"] = {32, 42};
      ["36"] = {32, 42};
      ["37"] = {32, 42};
      ["38"] = {32, 42};
    };
  };
  --]]
  ["EX01Silvermoon"] = {
    ["x"] = FixR:Round(99+1/3) * TexSizeX;
    ["y"] = -09 * TexSizeY;
    ["xL"] = 40;
    ["yL"] = 06;
    ["name"] = "Expansion01";
    ["layer"] = "OVERLAY";
    ["tiles"] = {
      ["40"] = {11, 18};["41"] = {11, 18};["42"] = {11, 20};["43"] = {11, 21};["44"] = {11, 21};["45"] = {11, 21};["46"] = {11, 21};["47"] = {11, 20};["48"] = {11, 20};["49"] = {14, 20};["50"] = {16, 20};
      --["51"] = {16, 21};
      --["52"] = {16, 21};
    };
  };
  ["SunwellPlateau"] = {
    ["x"] = FixR:Round(100+5/6-1/12) * TexSizeX;
    ["y"] = -09 * TexSizeY;
    ["xL"] = 28;
    ["yL"] = 26;
    ["name"] = "SunwellPlateau";
    ["tiles"] = {
      ["28"] = {26, 30};["29"] = {26, 30};["30"] = {26, 30};["31"] = {26, 30};["32"] = {26, 30};
    };
  };
  ["Northrend"] = {
    ["x"] = 44 * TexSizeX;
    ["y"] = 0 * TexSizeY;
    ["xL"] = 11;
    ["yL"] = 10;
    ["name"] = "Northrend";
    ["tiles"] = {
      --[[
      ["11"] = {12, 33};
      ["12"] = {12, 33};
      ["13"] = {12, 33};
      ["14"] = {12, 33};
      ["15"] = {12, 33};
      ["16"] = {12, 33};
      --]]
      ["17"] = {12, 33};["18"] = {12, 33};["19"] = {12, 33};["20"] = {12, 33};["21"] = {12, 33};["22"] = {12, 33};["23"] = {12, 33};["24"] = {12, 33};["25"] = {12, 33};["26"] = {12, 33};["27"] = {12, 33};["28"] = {12, 33};["29"] = {12, 33};["30"] = {12, 33};["31"] = {12, 33};["32"] = {12, 33};["33"] = {12, 33};["34"] = {12, 33};["35"] = {12, 33};["36"] = {12, 33};["37"] = {12, 33};["38"] = {12, 33};["39"] = {12, 33};["40"] = {12, 33};["41"] = {12, 33};["42"] = {12, 33};["43"] = {12, 33};["44"] = {12, 33};
      --[[
      ["45"] = {12, 33};
      ["46"] = {12, 33};
      ["47"] = {12, 33};
      ["48"] = {12, 33};
      ["49"] = {12, 33};
      --]]
    };
  };
  ["Kalimdor"] = {
    ["x"] = 12 * TexSizeX;
    ["y"] = -14 * TexSizeY;
    ["xL"] = 19;
    ["yL"] = 09;
    ["name"] = "Kalimdor";
    ["tiles"] = {
      --[[
      ["19"] = {12, 16};
      ["20"] = {12, 16};
      ["21"] = {12, 16};
      ["22"] = {12, 18};
      ["23"] = {12, 18, 37, 45};
      ["24"] = {12, 18, 32, 45};
      --]]
      ["23"] = {37, 45};["24"] = {32, 45};["25"] = {10, 15, 25, 55};["26"] = {10, 16, 25, 55};["27"] = {10, 16, 25, 55};["28"] = {10, 55};["29"] = {10, 55};["30"] = {10, 55};["31"] = {10, 55};["32"] = {10, 55};["33"] = {10, 55};["34"] = {12, 55};["35"] = {12, 55};["36"] = {12, 55};["37"] = {12, 55};["38"] = {12, 55};["39"] = {12, 55};["40"] = {12, 55};["41"] = {12, 55};["42"] = {12, 55};["43"] = {12, 49};["44"] = {12, 40};["45"] = {12, 33};["46"] = {12, 33};["47"] = {12, 16, 20, 33};["48"] = {12, 16, 21, 33};["49"] = {12, 16, 21, 33};["50"] = {12, 16, 26, 33};["51"] = {26, 33};["52"] = {26, 33};["53"] = {26, 33};["54"] = {26, 33};["55"] = {26, 33};["56"] = {26, 33};
    };
  };
  ["EX01Isles"] = {
    ["x"] = 9 * TexSizeX;
    ["y"] = -17 * TexSizeY;
    ["xL"] = 49;
    ["yL"] = 31;
    ["name"] = "Expansion01";
    ["tiles"] = {
      --["49"] = {32, 42};
      ["50"] = {32, 36};["51"] = {32, 42};["52"] = {32, 42};["53"] = {32, 42};["54"] = {32, 42};["55"] = {32, 42};["56"] = {32, 42};["57"] = {37, 42};["58"] = {37, 42};["59"] = {37, 42};
      --["60"] = {36, 42};
    };
  };
  ["Pandaria"] = {
    ["x"] = 49 * TexSizeX;
    ["y"] = -49 * TexSizeY;
    ["xL"] = 16;
    ["yL"] = 18;
    ["name"] = "HawaiiMainLand";
    ["tiles"] = {
      --["16"] = {18, 41};
      --["17"] = {18, 41};
      --["18"] = {18, 41};
      ["19"] = {18, 21, 26, 27};["20"] = {18, 36};["21"] = {18, 36};["22"] = {18, 36};["23"] = {18, 36};["24"] = {21, 36};["25"] = {21, 36};["26"] = {21, 36};["27"] = {21, 38};["28"] = {21, 38};["29"] = {21, 38};["30"] = {21, 38};["31"] = {21, 38};["32"] = {21, 36};["33"] = {24, 36};["34"] = {24, 36};["35"] = {24, 36};["36"] = {24, 36};["37"] = {25, 36};["38"] = {25, 36};["39"] = {28, 36};
      --["40"] = {21, 41};
      --["41"] = {21, 41};
      --["42"] = {21, 41};
      --["43"] = {21, 41};
    };
  };
};

local function updateMapPosition(x, y)
  TexFrame:SetPoint("TOPLEFT", MMFrame, "TOPLEFT", x, y)
  --print("TexFrame:SetPoint(\"TOPLEFT\", MMFrame, \"TOPLEFT\", "..x..", "..y..")")
  --[[
  local textures = {} --x=1..128, y=1..84
  fixrTextures = nil
  local texSizeTotal = {
    ["w"] = 128 * TexSizeX;
    ["h"] = 84 * TexSizeY;
  };
  --]]
  M:updateVisibility()
end

local function updateMapPositionAtCursor()
  draggingUpdateLocked = true
  local nowCursorX, nowCursorY = M:GetMousePosition(TexFrame);
  if (nowCursorX ~= lastCursorX) or (nowCursorY ~= lastCursorY) then
    lastMapOffX = lastMapOffX + (nowCursorX - lastCursorX)
    lastMapOffY = lastMapOffY + (nowCursorY - lastCursorY)
    lastCursorX = nowCursorX - (nowCursorX - lastCursorX)
    lastCursorY = nowCursorY - (nowCursorY - lastCursorY)
    updateMapPosition(lastMapOffX, lastMapOffY)
  end
  draggingUpdateLocked = false
end

local function MMFrame_OnUpdate(self, elapsed)
  timeSinceLastUpdate = timeSinceLastUpdate + elapsed
  if (timeSinceLastUpdate >= updateInterval) then
    if dragging and not draggingUpdateLocked then
      updateMapPositionAtCursor()
    end
    timeSinceLastUpdate = 0
  end
end

function M:initFrames()
  MMFrame = CreateFrame("Frame", nil, UIParent)
  MMFrame:SetPoint("CENTER")
  MMFrame:SetSize(300, 300)
  MMFrame.texture = MMFrame:CreateTexture()
  MMFrame.texture:SetAllPoints(MMFrame)
  MMFrame.texture:SetTexture(0.2, 0.2, 1, 0.5) --light blue
  MMFrame:Show()
  
  MMFrame:SetScript("OnUpdate", MMFrame_OnUpdate)

  TexFrame = CreateFrame("Frame", nil, MMFrame)
  TexFrame:SetPoint("TOPLEFT")
  TexFrame:SetFrameStrata("LOW")
  TexFrame:SetFrameLevel(1)
  --[ [
  TexFrame.texture = TexFrame:CreateTexture()
  TexFrame.texture:SetAllPoints(TexFrame)
  TexFrame.texture:SetTexture(1, 0.2, 0.2, 0.1) --light red
  --] ]
  
  TexFrame:SetScript("OnDragStart", function(self)
    self:StartMoving()
  end);
  TexFrame:SetScript("OnDragStop", function(self)
    self:StopMovingOrSizing()
    local selfES = self:GetEffectiveScale()
    local mmES = MMFrame:GetEffectiveScale()
    local selfS = self:GetScale()
    local newX, newY = FixR:Round((self:GetLeft()*selfES - MMFrame:GetLeft()*mmES) / selfS, 2), FixR:Round((self:GetTop()*selfES - MMFrame:GetTop()*mmES) / selfS, 2)
    updateMapPosition(newX, newY)
  end);
  TexFrame:SetScript("OnMouseDown", function(self, ...)
    _, _, _, lastMapOffX, lastMapOffY = TexFrame:GetPoint()
    lastCursorX, lastCursorY = M:GetMousePosition(self);
    dragging = true
  end);
  TexFrame:SetScript("OnMouseUp", function(self, ...)
    local x, y = M:GetMousePosition(self)
    updateMapPositionAtCursor()
    dragging = false
  end);
  TexFrame:SetScript("OnMouseWheel", function(self, delta)
    --delta=1: ScrollUp, delta=-1: ScrollDown
    if delta == 1 then
      newScale = newScale + ScaleInterval
      newScale = math.min(ScaleMax, newScale)
      M:updateScale()
    else
      newScale = newScale - ScaleInterval
      newScale = math.max(ScaleMin, newScale)
      M:updateScale()
    end
  end);
  
  TexFrame:SetMovable(true)
  TexFrame:EnableMouse(true)
  TexFrame:EnableMouseWheel(true)
  --TexFrame:RegisterForDrag("LeftButton")
  --TexFrame:RegisterForClicks("LeftButtonDown"); --only for buttons
  
  TexFrame:SetScript("OnEvent", function(self, event, ...)
    MMFrameEvents[event](self, ...); -- call one of the functions above
  end);
  TexFrame:Show()
end

function M:updateScale()
  print("Scale="..newScale)
  
  local newW, newH = TexSizeX * Scale, TexSizeY * Scale
  
  --[[
  TexFrame:SetSize(texSizeTotal["w"] * Scale, texSizeTotal["h"] * Scale)
  if texSizeTotal["w"] * Scale ~= TexFrame:GetWidth() or texSizeTotal["h"] * Scale ~= TexFrame:GetHeight() then
    print(texSizeTotal["w"] * Scale, TexFrame:GetWidth(), texSizeTotal["h"] * Scale, TexFrame:GetHeight())
    TexFrame:SetSize(texSizeTotal["w"] * Scale, texSizeTotal["h"] * Scale)
    if texSizeTotal["w"] * Scale ~= TexFrame:GetWidth() or texSizeTotal["h"] * Scale ~= TexFrame:GetHeight() then
      print(texSizeTotal["w"] * Scale, TexFrame:GetWidth(), texSizeTotal["h"] * Scale, TexFrame:GetHeight())
    end
  end
  --]]
  
  --[[
  for i, v in ipairs(activeTexs) do
    v:SetSize(newW, newH)
    v:SetPoint("TOPLEFT", v["x"] * Scale, v["y"] * Scale)
  end
  --]]
  for x, v in pairs(textures) do
    for y, v2 in pairs(v) do
      v2:SetSize(newW, newH)
      v2:SetPoint("TOPLEFT", x * Scale, y * Scale)
    end
  end
  
  --local cFrameW = newW * 10
  --local cFrameH = newH * 10
  for n, v in ipairs(ContinentFrames) do
    for i = 1, 12 do
      local cFrameW, cFrameH = v[i]["w"] * Scale, v[i]["h"] * Scale
      v[i]:SetSize(cFrameW, cFrameH)
      v[i]:SetPoint("TOPLEFT", v[i]["x"] * Scale + cFrameW*mod(i-1,4), v[i]["y"] * Scale - cFrameH*floor((i-1)/4))
    end
  end
  
  for n, v in ipairs(WorldFrames) do
    for i = 1, 12 do
      local wFrameW, wFrameH = v[i]["w"] * Scale, v[i]["h"] * Scale
      v[i]:SetSize(wFrameW, wFrameH)
      v[i]:SetPoint("TOPLEFT", v[i]["x"] * Scale + wFrameW*mod(i-1,4), v[i]["y"] * Scale - wFrameH*floor((i-1)/4))
    end
  end
  
  TexFrame:SetScale(newScale)
  
  if newScale <= WorldFramesScaleShowFull then
    for n, v in ipairs(WorldFrames) do
      for i = 1, 12 do
        v[i]:SetAlpha(1)
      end
    end
  elseif newScale >= WorldFramesScaleHide then
    for n, v in ipairs(WorldFrames) do
      for i = 1, 12 do
        v[i]:SetAlpha(0)
      end
    end
  else
    --(m) * (x) + n
    --(-1 / (WorldFramesScaleHide - WorldFramesScaleShowFull)) * (newScale - WorldFramesScaleShowFull) + 1
    for n, v in ipairs(WorldFrames) do
      for i = 1, 12 do
        v[i]:SetAlpha((-1 / (WorldFramesScaleHide - WorldFramesScaleShowFull)) * (newScale - WorldFramesScaleShowFull) + 1)
      end
    end
  end
  
  M:updateVisibility()
end

function M:loadMap()
  
  f = TexFrame
  f:SetPoint("CENTER")
  f:SetSize(texSizeTotal["w"], texSizeTotal["h"])
  
  
  local texOffsetX, texOffsetY = 0, 0
  local index = 1
  
  for k, v in pairs(texOffsets) do
          
    for x, ys in pairs(v["tiles"]) do
      local i = 1
      while (ys[i] and ys[i+1]) do
        local yLow, yHigh = ys[i], ys[i+1]
        for y = yLow, yHigh do
          local tex
          if v["layer"] then
            tex = f:CreateTexture(nil, v["layer"])
          else
            tex = f:CreateTexture(nil, "ARTWORK")
          end
          local absX, absY = v["x"] + (x - v["xL"]) * TexSizeX, v["y"] - (y - v["yL"]) * TexSizeY
          tex.x = absX
          tex.y = absY
          tex:SetTexture(format("World\\Minimaps\\%s\\map%d_%d.blp", v["name"], x, y))
          --activeTexs[index] = tex
          if not textures[absX] then
            textures[absX] = {}
          end
          textures[absX][absY] = tex
          --index = index + 1
        end
        i = i + 2
      end
    end
    
  end
  
  fixrTextures = textures
  
  for n, v in ipairs(texOffsetsContinents) do
    ContinentFrames[n] = {}
    for i = 1, 12 do
      --cFrame = CreateFrame("Frame", nil, TexFrame)
      local cFrame = CreateFrame("Frame", nil, TexFrame)
      ContinentFrames[n][i] = cFrame
      local tex = cFrame:CreateTexture()
      tex:SetAllPoints(cFrame)
      cFrame.tex = tex
      tex:SetTexture("Interface\\WorldMap\\"..v["name"].."\\"..v["name"]..i)
      cFrame.x = v["x"];
      cFrame.y = v["y"];
      cFrame.w = v["w"];
      cFrame.h = v["h"];
      cFrame:SetFrameStrata("LOW")
      cFrame:SetFrameLevel(2)
      cFrame:Show()
      --[[
      /run cFrame_1:SetSize(100, 100)
      /run cFrame_1:SetSize(100, 50);cFrame_1.tex:SetTexCoord(0,1,0,0.5) --Carbonite.lua:7165
      --]]
    end
  end
  
  for n, v in ipairs(texOffsetsWorld) do
    WorldFrames[n] = {}
    for i = 1, 12 do
      local wFrame = CreateFrame("Frame", nil, TexFrame)
      WorldFrames[n][i] = wFrame
      local tex = wFrame:CreateTexture()
      tex:SetAllPoints(wFrame)
      wFrame.tex = tex
      tex:SetTexture("Interface\\WorldMap\\"..v["name"].."\\"..v["name"]..i)
      --tex:SetVertexColor(1,1,1,0.5)
      wFrame.x = v["x"];
      wFrame.y = v["y"];
      wFrame.w = v["w"];
      wFrame.h = v["h"];
      wFrame:SetFrameStrata("LOW")
      wFrame:SetFrameLevel(3)
      wFrame:SetAlpha(0.5)
      wFrame:Show()
      --[[
      /run cFrame_1:SetSize(100, 100)
      /run cFrame_1:SetSize(100, 50);cFrame_1.tex:SetTexCoord(0,1,0,0.5) --Carbonite.lua:7165
      --]]
    end
  end
  
  M:updateScale()
end

function M:updateVisibility()
  local x1, x2, y1, y2 = M:GetVisibleArea()
  for x, v in pairs(textures) do
    if x < (x1-TexSizeX) then --left
      for y, v2 in pairs(v) do
        v2:Hide()
      end
    elseif x > x2 then --right
      for y, v2 in pairs(v) do
        v2:Hide()
      end
    else
      for y, v2 in pairs(v) do
        if y > (y1+TexSizeY) then --top
          v2:Hide()
        elseif y < y2 then --bottom
          v2:Hide()
        else
          v2:Show()
        end
      end
    end
  end
end

function M:GetVisibleArea()
  local mapw1 = MMFrame:GetWidth()
  local maph1 = MMFrame:GetHeight()
  local texs1 = TexFrame:GetScale()
  local point, relativeTo, relativePoint, xOfs, yOfs = TexFrame:GetPoint()
  
  return -xOfs, -xOfs + mapw1/texs1, -yOfs, -yOfs - maph1/texs1
end
function fixrMinimap_GetVisibleArea()
  return M:GetVisibleArea()
end
--/run fixrMinimap_CenterMapAt(0,0)
function fixrMinimap_CenterMapAt(x, y)
  local mapx1 = MMFrame:GetLeft()
  local mapy1 = MMFrame:GetTop()
  local mapw1 = MMFrame:GetWidth()
  local maph1 = MMFrame:GetHeight()
  local maps1 = MMFrame:GetEffectiveScale()
  local mapx2 = TexFrame:GetLeft()
  local mapy2 = TexFrame:GetTop()
  local mapw2 = TexFrame:GetWidth()
  local maph2 = TexFrame:GetHeight()
  local maps2 = TexFrame:GetEffectiveScale()
  --print("1 mapFrame x,y,w,h,s:", mapx1, mapy1, mapw1, maph1, maps1)
  --print("2 texFrame x,y,w,h,s:", mapx2, mapy2, mapw2, maph2, maps2)
  
  --updateMapPosition(x, y)
  
  updateMapPosition(-x + (mapw1 / 2) / TexFrame:GetScale(), -y - (maph1 / 2) / TexFrame:GetScale())
end
--/run print(fixrMinimap_GetMapCenter())
function fixrMinimap_GetMapCenter()
  local mapw1 = MMFrame:GetWidth()
  local maph1 = MMFrame:GetHeight()
  local point, relativeTo, relativePoint, xOfs, yOfs = TexFrame:GetPoint()
  return (-xOfs + (mapw1 / 2) / TexFrame:GetScale()), (-yOfs - (maph1 / 2) / TexFrame:GetScale())
end
function M:GetMousePosition(texFrame)
  local f=texFrame
  local x,y=GetCursorPosition()
  x=x/f:GetEffectiveScale()
  y=y/f:GetEffectiveScale()
  return x-f:GetLeft(), y-f:GetTop()
end

function M:Load()
  if MMFrame == nil then  
    M:initFrames()
    M:loadMap()
  end
  for k, v in pairs(MMFrameEvents) do
    MMFrame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
  MMFrame:Show()
end
function M:Unload()
  if MMFrame then
    for k, v in pairs(MMFrameEvents) do
      MMFrame:UnregisterEvent(k); -- Unregister all events for which handlers have been defined
    end
    MMFrame:Hide()
    --TexFrame:Hide()
  end
end

function M:SetOption(arg1)
  print(M:GetVisibleArea())
end